#******************************************************
# Find the Centre of selected objects
# 
# - centrefinder.py
# - Finds the Centre of Selected Objects
# - By Mark Caldwell
# - Version 0.2
# - Version 0.1 9th May 2006
# - Version 0.2 9th November 2008
# - Copyright Mark Caldwell 2006
# - Tested with Vue 7 Infinite
#
# How to use in 3 easy steps
#
# 1. Download this file onto your computer
#
# 2. Select Objects to be find centre of
#
# 3. Then run script and wait for it to work
#    To run it go to Python -> Run Python Script
#    Then locate the file on your computer
#
# Note: I'm from the UK so I use UK English spellings
#       If you prefer the US spelling for Centre
#       edit this file to put a # in front of
#       centreName='Centre' and remove the one from the
#       line after it centreName='Center'
# 
#******************************************************

centreName='Centre'    # Comment this line for US spelling
# centreName='Center'  # Uncomment this line for US spelling

#----------------------------------------------
# Internal Variables Set Up: Don't alter these
#----------------------------------------------

countobj=CountSelectedObjects()
centre=[0,0,0]

#----------------------------------------------
# Find Selected Objects Calculate the Centre
#----------------------------------------------
if countobj>1:
    for i in range(0,countobj):
        object=GetSelectedObjectByIndex(i)
        pos=object.Position()
        centre[0]=centre[0]+pos[0]
        centre[1]=centre[1]+pos[1]    
        centre[2]=centre[2]+pos[2]

    centre[0]=centre[0]/countobj
    centre[1]=centre[1]/countobj
    centre[2]=centre[2]/countobj

#----------------------------------------------
# Find Selected Objects 
#----------------------------------------------

    cube=AddCube()

    cube.SetPosition(centre[0],centre[1],centre[2])

    cube.SetName(centreName)

#----------------------------------------------
# Refresh Vue's Display
#----------------------------------------------

    Refresh()

#----------------------------------------------
# End of Script
#----------------------------------------------    
   

    

